﻿using System;   
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFighter
{
    internal class MyMap : AbstractMap
    {

        /// <summary>
        /// Цвет участка закрытого
        /// </summary>
        private readonly Brush barrierColor = new SolidBrush(Color.Black);
        
        /// <summary>
        /// Цвет участка открытого
        /// </summary>
        private readonly Brush roadColor = new SolidBrush(Color.Gray);
        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(barrierColor, j * _size_x, i * _size_y, _size_x, _size_y);
        }
        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(roadColor, j * _size_x, i * _size_y, _size_x, _size_y);
        }
        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);

            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            }


            for(int i = 0; i < 20; ++i)
            {
                int x = _random.Next(0, 100);
                int y = _random.Next(0, 100);

                GenerateMap(x, y, _random.Next(13, 23));
            }

        }

        private void GenerateMap(int x, int y, int depth)
        {
            if (depth <= 0) return;
            bool check = false;

            while (!check)
            {
                int deltaX = _random.Next(-1, 2);
                int deltaY = _random.Next(-1, 2);

                if (x + deltaX < 0 || x + deltaX >= 100) continue;
                if (y + deltaY < 0 || y + deltaY >= 100) continue;

                if (_map[y + deltaY, x + deltaX] == _barrier) depth--;
                x += deltaX;
                y += deltaY;

                _map[y, x] = _barrier;

                check = true;
            }

            GenerateMap(x, y, depth - 1);
        }
    }
}
